<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
            "http://www.w3.org/TR/html4/strict.dtd">
<head>
<title>This FTP site</title>
<meta name="description" content="Main index of okmij.org">
<meta name="Author" content="oleg-at-okmij.org">
<meta name="Date-Revision-yyyymmdd" content="20231201">
<meta name="Date-Creation-yyyymmdd" content="19950611">
<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="canonical" href="https://okmij.org/ftp/">
<link title="RSS Feed" type="application/rss+xml" rel="alternate" href="rss.xml">
<link title="Atom Feed" type="application/atom+xml" rel="alternate" href="atom.xml">
<meta name="google-site-verification" content="Xt6WMO1bGfJ4F79-_CKBrimYOQl9axceJlE--lHysGs">
<style type="text/css">BODY { background-color: white; color: black } .heading { text-align: center; } .small  { font-size: 90%;} dd { margin-left: 0pt; margin-bottom: 1em; margin-top: 2px;}</style></head>
<body>
<h1 class="heading">Index</h1>
<p class="heading">Unless specified otherwise, all the code and the documentation on this
site is in public domain</p>
<p class="heading"><a href="ChangeLog.html"><strong>Recent changes:</strong></a>&nbsp;<strong> December 1, 2023</strong>
&nbsp; | &nbsp;
<a href="rss.xml"><strong>RSS</strong></a>
&nbsp; | &nbsp;
<a href="atom.xml"><strong>Atom</strong></a><BR>
&nbsp;<BR>
</p>
<table rules="cols" cellpadding="10">
<col>
<col>
<tr valign="top">
<td>
<p><em>Shortcuts</em></p>
<p><a href="tagless-final/">tagless-final</a></p>
<p><a href="ML/MetaOCaml.html">MetaOCaml</a></p>
<p><a href="Streams.html">streams</a></p>
<p><a href="meta-programming/">staging</a></p>
<p><a href="ML/generalization.html">polymorphic type inference</a></p>
<p><a href="Haskell/extensible/">extensible effects</a></p>
<p><a href="Computation/typeclass.html">typeclass</a></p>
<p><a href="tagless-final/Algebra.html">Algebra</a></p>
<p><a href="Computation/lambda-calc.html">lambda calculus</a></p>
<p><a href="Streams.html">Iteratee, Enumerator</a></p>
<p><a href="Computation/free-monad.html">Freer monad</a></p>
<p><a href="tagless-final/NBE.html">NBE</a></p>
<p><a href="meta-programming/HPC.html#shonan-challenge">Shonan Challenge</a></p>
<p><a href="Streams.html">strymonas</a></p>
<p><a href="continuations/PPYield/">simple generators</a></p>
<p><a href="Computation/monads.html#LogicT">LogicT</a></p>
<p><a href="continuations/index.html#tutorial">shift tutorial</a></p>
<p><a href="continuations/implementations.html">delimcc</a></p>
<p><a href="continuations/against-callcc.html">call/cc</a></p>
<p><a href="Computation/monads.html#lazy-sharing-nondet">lazy non-determinism</a></p>
<p><a href="kakuritu/Hakaru10/">Hakaru10</a></p>
<p><a href="kakuritu/">Hansei</a></p>
<p><a href="continuations/zipper.html">zipper</a></p>
<p><a href="Scheme/xml.html">SXML</a></p>
<p><a href="Scheme/xml.html#XML-parser">SSAX</a></p>
<p><a href="Haskell/types.html#HList">HList</a></p>
<p><a href="Scheme/macros.html">macros</a></p>
<p><a href="Haskell/misc.html#perfect-shuffle">perfect random shuffle</a></p></td>
<td>
<table cellpadding="10" cellspacing="4">
<col>
<col>
<tr valign="top">
<td>
<dl>
<dt><strong><a href="Computation/">Computation</a></strong></dt>
<dd class="small">fixpoints;
<a href="Computation/having-effect.html">Having an Effect</a>;
<a href="Computation/monads.html">monads</a>;
<a href="Computation/index.html#collaborative-PL">programming as collaborative reference</a>;
effects without monads;
Turing machines;
Markov algorithms;
R-technology;
CK macros;
<a href="continuations/PPYield/index.html#randoms">generators vs. lazy evaluation</a>;
<a href="Computation/IO-monad-history.html">IO monad realized in 1965</a>;
<a href="Algorithms/grasping-all-apples-at-once.html">grasping patterns</a>;
the mystery of assignment is syntactic;
...
</dd>
<dt><strong><a href="Computation/types.html">Types</a></strong></dt>
<dd class="small"><a href="Computation/lightweight-static-guarantees.html">Safe and Efficient, Now</a>;
<a href="Computation/typeclass.html">typeclasses</a>;
<a href="ML/generalization.html">polymorphic type inference</a>;
<a href="Haskell/AlgorithmsH.html#teval">Hindley-Milner type inference course</a>;
<a href="Computation/extra-polymorphism.html">unusual polymorphism</a>;
<a href="Computation/types.html#sessions">session types without sophistry</a>;
<a href="Computation/Existentials.html">eliminating existentials</a>;
<a href="Haskell/extensible/">extensible effects</a>;
<a href="meta-programming/calculi.html#refined-classif">region memory management for free variables</a>;
type arithmetic;
...
</dd>
<dt><strong><a href="meta-programming/">Meta-programming</a></strong></dt>
<dd class="small">staging; implementations;
Reconciling abstraction with high performance: A MetaOCaml
approach;
<a href="ML/MetaOCaml.html">BER MetaOCaml</a>;
genlet(rec);
language-integrated query;
<a href="meta-programming/implementations.html#meta-haskell">Staged Haskell</a>;
generating Gaussian Eliminators;
impure but hygienic code generation;
FFT;
quines;
generating code with polymorphic let: A ballad of value restriction,
copying and sharing;
...   
</dd>
<dt><strong><a href="continuations/">Continuations</a></strong></dt>
<dd class="small">implementations;
tutorials;
delimited vs. undelimited;
Eff directly in OCaml;
<a href="continuations/against-callcc.html">against call/cc</a>;
<a href="continuations/generators.html">generators</a>;
<a href="continuations/zipper.html">zipper</a>;
<a href="continuations/undelimited.html#iter-recur">recursion from iteration</a>;
<a href="Computation/dynamic-binding.html">delimited dynamic binding</a>;
functional un|unparsing;
...
</dd>
<dt><strong><a href="formalizations/">Logic</a></strong></dt>
<dd class="small"><a href="Prolog/index.html#pure-arithm">recursively enumerating binary arithmetic relations</a>;
logical frameworks;
Twelf;
<a href="Haskell/impredicativity-bites.html">impredicativity</a>;
strengthening in logical frameworks;
eigen-variables: variables or constants?
type soundness proofs for calculi with delimited control;
...
</dd>
<dt><strong><a href="Algorithms.html">Algorithms and Data Structures</a></strong></dt>
<dd class="small">fast pretty-printing;
breadth-first labeling;
fast type-aligned queues;
arithmetic compression;
scheduling;
transforming cyclical structures;
shuffling; 
<a href="Haskell/AlgorithmsH.html#ccard-transform">the Credit Card transform</a>;
<a href="Algorithms/secure-count.html">secure counting</a>;
<a href="tagless-final/course/Boehm-Berarducci.html">beyond Church encoding: Boehm-Berarducci isomorphism</a>;
<a href="Haskell/polyvariadic.html#fast-forth">fast embedding of postfix languages</a>;
...
</dd>
<dt><strong><a href="Denotational.html">Denotational Semantics</a></strong></dt>
<dd class="small">query optimization;
not by equations alone;
normalization-by-evaluation;
compiling to combinators;
multiprompt delimited control;
tagless-final optimizations, algebraically;
evaluators, normalizers, reducers: from denotational to operational
semantics;
reference-type vs. mutable variables;
...   
</dd>
<dt><strong><a href="kakuritu/">Probabilistic Programming</a></strong></dt>
<dd class="small">Hansei; Hakaru10; Bayesian nets; HMM; population estimation;
Metropolis-Hastings for mixtures of conditional distributions;
problems of the lightweight implementation;
multi-target tracking; importance sampling;
reversible parsing combinators;
...
</dd>
<dt><strong><a href="Computation/monads.html">Non-determinism</a></strong></dt>
<dd class="small">LogicT;
purely functional lazy non-deterministic programming;
fair backtracking;
<a href="kakuritu/logic-programming.html#vs-prolog">re-thinking Prolog</a>;
<a href="Denotational.html#exteff">reasoning with non-determinism and state</a>;
<a href="kakuritu/logic-programming.html">declarative Logic Programming in ordinary languages</a>;
...
</dd>
<dt><strong><a href="gengo/">Linguistics</a></strong></dt>
<dd class="small">Lambek Grammars and ACG;
quantifier scope;
polynomial event semantics;
semantics of `same';
continuation semantics;
applicatives and monads;
Lambda: the ultimate syntax-semantics interface;
...
</dd>
<dt><strong><a href="Computation/">Essays</a></strong></dt>
<dd class="small"><a href="Computation/having-effect.html">in defense of effects</a>;
information and entropy; computers and infinity;
<a href="Computation/my-summaries.html">conference summaries</a>;
Principia Mathematica notes;
<a href="Babel/">computing in good old days</a>;
...</dd></dl></td>
<td>
<dl>
<dt><strong>Programming Languages</strong></dt>
<dd class="small"><a href="Haskell/">Haskell</a>;
<a href="ML/">ML</a>;
<a href="Scheme/">Scheme</a>;
<a href="Prolog/">Prolog</a>;
<a href="tagless-final/">typed DSL</a>;
<a href="cpp-digest/">C++</a>;
<a href="Perl/">Perl</a>;
<a href="Babel/">Others</a></dd>
<dt><strong><a href="Computation/lambda-calc.html">lambda calculus</a></strong></dt>
<dd class="small">many calculators and embeddings;
many predecessors;
new SKI translation: at last, compositional;
simplest polyvariadic fixpoint combinators;
alpha-conversion is inevitable;
pairs, sums, lists, etc. in simply-typed calculus;
...
</dd>
<dt><strong><a href="ML/">ML</a></strong></dt>
<dd class="small">extra-polymorphism;
typeclasses;
canonical structures;
MetaOCaml;
HList;
higher-kinded bounded polymorphism;
type representations;
shell/AWK/Perl-like scripting;
many embedded DSLs;
delimited continuations;
...
</dd>
<dt><strong><a href="Haskell/">Haskell</a></strong></dt>
<dd class="small">logical type programming; 
against lazy evaluation;
lightweight dependent types; keyword arguments;
HList; regions; set, restricted, etc. monads;
type-level equality, disequality and introspection;
...
</dd>
<dt><strong><a href="Scheme/">Scheme</a></strong></dt>
<dd class="small">XML; macros; text and binary parsing; utilities;
...
</dd>
<dt><strong><a href="Scheme/xml.html">XML</a></strong></dt>
<dd class="small">SXML; iteratee parsers; SSAX; parsing; SXSLT; SXPath;
typed SXML; ...
</dd>
<dt><strong><a href="NumMath.html">Numerical Math</a></strong></dt>
<dd class="small">LinAlg; SVD; FFT; lazy matrices; matrix streams;
<a href="meta-programming/HPC.html">code generation</a>;
...
</dd>
<dt><strong><a href="OS.html">OS</a></strong></dt>
<dd class="small">ZipperFS/OS; HTTP VFS; layered I/O; sh agents;
better than shell pipes;
DreamOS; Speaking HTTP; opening of extended file names; ...</dd>
<dt><strong>Image Processing</strong></dt>
<dd class="small"><a href="image/compression/">image compression</a>;
<a href="image/ArrayL/">playground with array languages, plasma fractals</a>;
<a href="Graphics.html#cpp.improc">grayscale image processing</a>;
<a href="Venus.html">flight through clouds</a>
</dd></dl></td></tr></table></td></tr></table></body>